#include <Servo.h>
#define SERVOPIN 5 // Servo Signal Pin
#define MOTOR_PWM 6 // --> Motor Input A
#define MOTOR_DIR 9 // --> Motor Input B
#define MINPOS 180 // servo down
#define MAXPOS 0 // servo up

int duration = 1;
byte stepcounter = 0;
int pos = 0;
unsigned long previousMillis = 0;
boolean motor = false;
int fanspeed = 0;

Servo myservo;  // create servo object to control a servo

void setup()
{
  pinMode(MOTOR_DIR, OUTPUT);
  pinMode(MOTOR_PWM, OUTPUT);
  digitalWrite(MOTOR_DIR, LOW);
  digitalWrite(MOTOR_PWM, LOW);
  myservo.attach(SERVOPIN);
}

void loop()
{
  fanspeed = analogRead(A0);
  fanspeed = map(fanspeed, 0, 1023, 150, 255);
  if (motor)
  {
    digitalWrite(MOTOR_DIR, LOW);
    analogWrite(MOTOR_PWM, fanspeed);
  }
  else
  {
    digitalWrite(MOTOR_DIR, LOW);
    digitalWrite(MOTOR_PWM, LOW);
  }
  unsigned long currentMillis = millis();
  if (currentMillis  - previousMillis > duration)
  {
    stepcounter++;
    switch (stepcounter)
    {
      case 1: // servo down
        myservo.write(MINPOS);
        duration = 1000;
        break;

      case 2: // servo up
        for (pos = MINPOS; pos >= MAXPOS; pos -= 1) {
          myservo.write(pos);
          delay(8);
        }
        duration = 2000;
        break;

      case 3: // motor on
        motor = true;
        duration = 5000;
        break;

      case 4: // motor off & servo down
        motor = false;
        duration = 1;
        break;
        
      case 5:
        motor = false;
        for (pos = MAXPOS; pos <= MINPOS; pos += 1) {
          myservo.write(pos);
          delay(8);
        }
        duration = 1;
        break;

      default: // start from beginning
        motor = false;
        stepcounter = 0;
        duration = 1;
    }
    previousMillis = currentMillis;
  }
}

